/*
 * FILE     : huteiEqu.cpp
 * FUNCTION : s
 * REFERENCE: 1987.7.30 ̃
 * AUTHOR   : 2021.8.31   N.Tsuchiya
1987NLSĨeXgŃXL񐔂]邽߂ɕKvƂȂĊĴłB
FORTRAN\[XƂɂ̎̊Odl̂܂܂ɂĂ܂B
 */
#include    <stdlib.h>
#if 0
/* ID_huteiEqu  LSIXL񐔁@ss + p * k = q * n + e 
****************************************************************************/
int huteiEqu(         /* ߂l 0: -1:ُ 1:Ȃ */
    int     n,        /* i  TCY0 < n  */
    int     k,        /* i  XLbvTCY */
    int     s,        /* i  Jnʒu */
    int     e,        /* i  I[ʒu */
    int     *p,       /* o  ړ 0*p|n/gcd|*/
    int     *q,       /* o  XCh */
    int     *gcd)     /* o  ő(n, k) ̏ꍇ */
{
    int     rc, c1, c2, n1, n2, x, y, z;
/*  */
    if( n == 0 || k == 0 ) goto                                       e902;
    c1 = 0; c2 = e-s;
    n1 = n; n2 = k;
    while( n2 != 0 ) { // [Nbȟݏ@̃[v
        x = n1 / n2;
        y = n1 - x * n2; n1 = n2; n2 = y;
        z = c1 - x * c2; c1 = c2; c2 = z;
    }
    *gcd = n1;
    if( ((e - s) % n1) != 0 ) goto                                   e901;
    *p = (c1 / n1) % (n / n1);
	if( *p < 0) *p += abs(n / n1); // *p0ۏ؂KvȂsv
    *q = (s - e + k * *p) / n;
    rc = 0;
quit:
    return(rc);
e901: rc = 1; //Ȃ
    *p = *q = -1;
    goto                                                               quit;
e902: rc = -1; //ُ
    *p = *q = *gcd = -1;
    goto                                                               quit;
}
#else  //z[y[Wfڃ\[X
/* ID_huteiEqu  LSIXL񐔁@ss + p * k = q * n + e 
****************************************************************************/
int huteiEqu(         /* ߂l 0: -1:ُ 1:Ȃ */
    int     n,        /* i  TCY0 < n  */
    int     k,        /* i  XLbvTCY */
    int     s,        /* i  Jnʒu */
    int     e,        /* i  I[ʒu */
    int     *p,       /* o  ړ 0*p|n/gcd|*/
    int     *q,       /* o  XCh */
    int     *gcd)     /* o  ő(n, k) ̏ꍇ */
{
    int     c1, c2, n1, n2, x, y, z;
    if( n == 0 || k == 0 ) {*p = *q = *gcd = -1; return -1;}
/*  */
    c1 = 0; c2 = e-s;
    n1 = n; n2 = k;
    while( n2 != 0 ) { //[Nbȟݏ@̃[v
        x = n1 / n2;
        y = n1 - x * n2; n1 = n2; n2 = y;
        z = c1 - x * c2; c1 = c2; c2 = z;
    }
    *gcd = n1;
    if( ((e - s) % n1) != 0 )  {*p = *q = -1; return 1;}
    *p = (c1 / n1) % (n / n1);
	if( *p < 0) *p += abs(n / n1); // *p0ۏ؂KvȂsv
	*q = (s - e + k * *p) / n;
    return(0);
}
#endif

#define TEST_huteiEqu
#ifdef TEST_huteiEqu
#include <stdio.h>
#include    <stdlib.h>
#include "s.txt"
int check1( //ss + p * k = q * n + e ̉`FbN
    int n, int k, int s, int e,
    int p, int q, int gcd
    )
{
    int rc = 0;
    double lh, rh;
	if( p < 0 ) 
		printf("error\n");
    lh = s + (double)p * k;
    rh = (double)q * n + e;
    if( lh != rh ) {
        printf("incorrrect ans lh(%g) rh(%g) \n", lh, rh );
        rc = -1;
    }
//    printf( "n(%d) k(%d) s(%d) e(%d)\tp(%d) q(%d) gcd(%d) lh(%g) rh(%g) \n", n, k, s, e, p, q, gcd, lh, rh );
    return rc;
}
int exec1(
    int n, int k, int s, int e,
    int *p, int *q, int *gcd )
{
    int rc;
    rc = huteiEqu( n, k, s, e, p, q, gcd );
    if( rc < 0 ) {
        printf( "W̕s " );
        printf( "n(%d) k(%d) s(%d) e(%d) p(%d) q(%d) gcd(%d)\n", n, k, s, e, *p, *q, *gcd );
    } else if( rc > 0 ) {
        printf( "Ȃ " );
        printf( "n(%d) k(%d) s(%d) e(%d) p(%d) q(%d) gcd(%d)\n", n, k, s, e, *p, *q, *gcd );
        e = e - (e - s) % *gcd;
        rc = huteiEqu( n, k, s, e, p, q, gcd );
        if( rc != 0 ) {
            printf( "gCs " );
            printf( "n(%d) k(%d) s(%d) e(%d) p(%d) q(%d) gcd(%d)\n", n, k, s, e, *p, *q, *gcd );
        }
    }
    if( rc == 0 ) {
        rc = check1( n, k, s, e, *p, *q, *gcd );
    }
    return rc;
}
struct hutei {
    int n, k, s, e;
};
static hutei data[] = {
    {26, 10, 0, 6 }
    ,{16, -10, 0, 6 }
    ,{-16, 10, 0, 0 }
    ,{0, 10, 0, 20 }
};
int main() {
    int     i, nn, rg, rr, rc, p, q, gcd, n=sizeof(data)/sizeof(data[0]) ;
    hutei ht = data[1];

//  int a = -7 / -3, b = -7 % -3;  // 2, -1
//  int c =  7 / -3, d =  7 % -3;  //-2,  1
//  int e = -7 /  3, f = -7 %  3;  //-2, -1
//  i = a+b+c+d+e+f;

    for( i = 0; i < 4; ++i ) {
        ht = data[i];
        rc = exec1( ht.n, ht.k, ht.s, ht.e, &p, &q, &gcd );
    }
    nn = 10000;
    rg = 4000; //256;
    rr = 2000; //128;
    for( i = 0; i < nn; ++i ) {
        ht.n = rand() % rg - rr;
        ht.k = rand() % rg - rr;
        if( ht.n == 0 ) ht.n = 1;
        if( ht.k == 0 ) ht.k = 1;
        ht.s = rand() % rg - rr;
        ht.e = rand() % rg - rr;
        rc = exec1( ht.n, ht.k, ht.s, ht.e, &p, &q, &gcd );
    }
    printf( "nn(%d)s\n", nn );
    return(0);
}
#endif
